---
title: Element.setAttributeNS()
slug: Web/API/Element/setAttributeNS
tags:
  - API
  - DOM
  - Element
  - Method
  - Reference
---
<p>{{ APIRef("DOM") }}</p>

<p><code>setAttributeNS</code> adds a new attribute or changes the value of an attribute with the given namespace and name.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.setAttributeNS(<em>namespace</em>, <em>name</em>, <em>value</em>)
</pre>

<ul>
	<li><code>namespace</code> is a string specifying the namespace of the attribute.</li>
	<li><code>name</code> is a string identifying the attribute by its qualified name; that is, a namespace prefix followed by a colon followed by a local name.</li>
	<li><code>value</code> is the desired string value of the new attribute.</li>
</ul>

<h2 id="Example">Example</h2>

<pre class="brush: js">let d = document.getElementById('d1');
d.setAttributeNS('<span class="nowiki">http://www.mozilla.org/ns/specialspace</span>', 'spec:align', 'center');
</pre>

<h2 id="Notes">Notes</h2>

<p>{{ DOMAttributeMethods() }}</p>

<p><code>setAttributeNS</code> is the only method for namespaced attributes which expects the fully qualified name, i.e. <code>"namespace:localname"</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-element-setattributens', 'document.setAttributeNS')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.setAttributeNS")}}</p>
